//
//  Person.m
//  点招练习OC
//新要求:
//  Created by mac on 16/5/6.
//  Copyright © 2016年 mac. All rights reserved.
/**
 思路分析:
 1.创建一个类,在类的实现中重写allocWithZone方法
 2.创建一个类方法---用于快速得到这个单例对象
 3.主函数,调用类方法创建这个单例对象
 */

#import "Person.h"

@implementation Person
//在类的实现中重写allocWithZone方法
+ (instancetype)allocWithZone:(struct _NSZone *)zone{
    //1. 声明1个静态变量instance, 默认值为nil
    static id instance = nil;
    //判断instance是否为nil
    if (instance == nil) {
        //创建对象.
        instance = [super allocWithZone:zone];
    }
    return instance;
}
//创建一个类方法---用于快速得到这个单例对象
+ (instancetype)sharedPerson{
    return [[self alloc] init];
}
+ (instancetype)defaultPerson{
    return [[self alloc] init];
}
@end
